const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const book_club_memberships = sequelize.define(
    'book_club_memberships',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

role: {
        type: DataTypes.ENUM,
      
      

        values: [

"member",


"moderator",


"owner"

        ],

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"invited",


"joined",


"left",


"banned"

        ],

      },

joined_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  book_club_memberships.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity







































//end loop



    db.book_club_memberships.belongsTo(db.book_clubs, {
      as: 'book_club',
      foreignKey: {
        name: 'book_clubId',
      },
      constraints: false,
    });

    db.book_club_memberships.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });




    db.book_club_memberships.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.book_club_memberships.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return book_club_memberships;
};


